UNIT MouseWheel;
//=====================================================
// TMouseWheel component
// Written 10/31/1998 By John "Ben" Davis
// Purpose: Provide a simple component for using the
//          mouse wheel on the Microsoft Intellimouse
//          (and compatible) for scrolling controls.
// Usage: Drop the component on a form containing controls
//        that feature scrollbars.
// Coded for Delphi 3.0 from information found in the
// Developer Support section of Microsoft's website.
// Supported OS:
//  Windows NT v4.0 or later.
//  Windows 98.
// There are no warranties expressed or implied.  The
// author assumes no liability arising from the use or
// misuse of this product.
//=====================================================
INTERFACE

USES
  Windows, Messages, SysUtils,
  Classes, Graphics, Controls,
  Forms,   Dialogs;

TYPE
  TMouseWheel = CLASS(TComponent)
    PROCEDURE WMMouseWheel(VAR Msg: TMessage); MESSAGE WM_MOUSEWHEEL;
  PRIVATE
  PROTECTED
  PUBLIC
  PUBLISHED
  END;

PROCEDURE Register;

IMPLEMENTATION

PROCEDURE TMouseWheel.WMMouseWheel(VAR Msg: TMessage);
//RESPOND TO THE MOUSE WHEEL MOVEMENT.
VAR ScrollMsg: TMessage;
BEGIN
  IF ComponentState = [csDesigning] THEN
    Exit;
  //DETERMINE IF THE MOUSE WHEEL WAS SCROLLED
  //BACKWARDS OR FORWARD:
  IF ShortInt(Msg.WParamHi) = -120 THEN
    ScrollMsg.WParamLo := SB_PAGEUP
  ELSE
  IF ShortInt(Msg.WParamHi) = 120 THEN
    ScrollMsg.WParamLo := SB_PAGEDOWN;
  //CONVERT THE MESSAGE TO A SCROLL MESSAGE
  //AND SEND TO THE FORM.
  ScrollMsg.Msg := WM_VSCROLL;
  Self.Owner.Dispatch(ScrollMsg);
END;

PROCEDURE Register;
BEGIN
  RegisterComponents('Samples', [TMouseWheel]);
END;

END.
